Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_allocation.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_allocation.cpp	(revision 128)
@@ -292,58 +292,64 @@
      
     // ~~~~~[ Instanciation ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
-    std::string name_component;
+    std::string src,dest;
     
     for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
       {
-	name_component = _name+"_gpr_"+toString(i);
+	src = _name+"_gpr_"+toString(i);
 	
-        log_printf(INFO,Register_unit,FUNCTION,_("Instance : %s"),name_component.c_str());
+        log_printf(INFO,Register_unit,FUNCTION,_("Instance : %s"),src.c_str());
 	
-#ifdef POSITION
-	_component->interface_map (name_component,"",
-				   _name         ,"");
-#endif
-	
-	_component->port_map(name_component,"in_CLOCK"   , _name, "in_CLOCK");
-	_component->port_map(name_component,"in_NRESET"  , _name, "in_NRESET");
+        {
+          dest = _name;
+#ifdef POSITION
+          _component->interface_map (src ,"",
+                                     dest,"");
+#endif
+          PORT_MAP(_component,src , "in_CLOCK" ,dest, "in_CLOCK");
+          PORT_MAP(_component,src , "in_NRESET",dest, "in_NRESET");
+        }
 
 	for (uint32_t j=0; j<_param->_nb_gpr_read; j++)
 	  {
-	    _component->port_map(name_component,
-				 "in_READ_"+toString(j)+"_VAL",
-				 _name+"_glue",
-				 "out_GPR_READ_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_VAL");
-	    _component->port_map(name_component,
-				 "out_READ_"+toString(j)+"_ACK",
-				 _name+"_glue",
-				 "in_GPR_READ_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_ACK");
-	    _component->port_map(name_component,
-				 "out_READ_"+toString(j)+"_DATA",
-				 _name+"_glue",
-				 "in_GPR_READ_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_DATA");
-	    _component->port_map(name_component,
-				 "in_READ_"+toString(j)+"_ADDRESS",
-				 _name,
-				 "in_GPR_READ_"+toString(j)+"_NUM_REG");
+            dest = _name+"_glue";
+            
+#ifdef POSITION
+            _component->interface_map (src ,    "read_"+toString(j),
+                                       dest,"gpr_read_registerfile_"+toString(i)+"_"+toString(j));
+#endif
+
+	    COMPONENT_MAP(_component,src , "in_READ_"                                 +toString(j)+"_VAL",
+                                     dest,"out_GPR_READ_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_VAL");
+	    COMPONENT_MAP(_component,src ,"out_READ_"                                 +toString(j)+"_ACK",
+                                     dest, "in_GPR_READ_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_ACK");
+	    COMPONENT_MAP(_component,src ,"out_READ_"                                 +toString(j)+"_DATA",
+                                     dest, "in_GPR_READ_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_DATA");
+
+            dest = _name;
+
+	    PORT_MAP     (_component,src , "in_READ_"    +toString(j)+"_ADDRESS",
+                                     dest, "in_GPR_READ_"+toString(j)+"_NUM_REG");
 	  }
+
 	for (uint32_t j=0; j<_param->_nb_gpr_write; j++)
 	  {
-	    _component->port_map(name_component,
-				 "in_WRITE_"+toString(j)+"_VAL",
-				 _name+"_glue",
-				 "out_GPR_WRITE_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_VAL");
-	    _component->port_map(name_component,
-				 "out_WRITE_"+toString(j)+"_ACK",
-				 _name+"_glue",
-				 "in_GPR_WRITE_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_ACK");
-	    _component->port_map(name_component,
-				 "in_WRITE_"+toString(j)+"_ADDRESS",
-				 _name,
-				 "in_GPR_WRITE_"+toString(j)+"_NUM_REG"
-				 );
-	    _component->port_map(name_component,
-				 "in_WRITE_"+toString(j)+"_DATA",
-				 _name,
-				 "in_GPR_WRITE_"+toString(j)+"_DATA");
+            dest = _name+"_glue";
+            
+#ifdef POSITION
+            _component->interface_map (src ,    "write_"+toString(j),
+                                       dest,"gpr_write_registerfile_"+toString(i)+"_"+toString(j));
+#endif
+
+	    COMPONENT_MAP(_component,src , "in_WRITE_"                                 +toString(j)+"_VAL",
+                                     dest,"out_GPR_WRITE_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_VAL");
+	    COMPONENT_MAP(_component,src ,"out_WRITE_"                                 +toString(j)+"_ACK",
+                                     dest, "in_GPR_WRITE_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_ACK");
+
+            dest = _name;
+
+	    PORT_MAP     (_component,src , "in_WRITE_"    +toString(j)+"_ADDRESS",
+                                     dest, "in_GPR_WRITE_"+toString(j)+"_NUM_REG");
+	    PORT_MAP     (_component,src , "in_WRITE_"    +toString(j)+"_DATA",
+                                     dest, "in_GPR_WRITE_"+toString(j)+"_DATA");
 	  }
 
@@ -353,34 +359,38 @@
       for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
 	{
-	  name_component = _name+"_gpr_status_"+toString(i);
+	  src = _name+"_gpr_status_"+toString(i);
 	  
-	  log_printf(INFO,Register_unit,FUNCTION,_("Instance : %s"),name_component.c_str());
-	  
-#ifdef POSITION
-	  _component->interface_map (name_component,"",
-				     _name         ,"");
-#endif
-	  
-	  _component->port_map(name_component,"in_CLOCK" , _name, "in_CLOCK");
-	  _component->port_map(name_component,"in_NRESET", _name, "in_NRESET");
-	  
+	  log_printf(INFO,Register_unit,FUNCTION,_("Instance : %s"),src.c_str());
+
+          {
+            dest = _name;
+#ifdef POSITION
+            _component->interface_map (src ,"",
+                                       dest,"");
+#endif
+            PORT_MAP(_component,src , "in_CLOCK" ,dest, "in_CLOCK");
+            PORT_MAP(_component,src , "in_NRESET",dest, "in_NRESET");
+          }
+          
 	  for (uint32_t j=0; j<_param->_nb_gpr_read; j++)
 	    {
-	      _component->port_map(name_component,
-				   "in_READ_"+toString(j)+"_VAL" ,
-				   _name+"_glue",
-				   "out_GPR_READ_STATUS_"+toString(i)+"_"+toString(j)+"_VAL"        );
-	      _component->port_map(name_component,
-				   "out_READ_"+toString(j)+"_ACK",
-				   _name+"_glue",
-				   "in_GPR_READ_STATUS_"+toString(i)+"_"+toString(j)+"_ACK" );
-	      _component->port_map(name_component,
-				   "out_READ_"+toString(j)+"_DATA",
-				   _name+"_glue",
-				   "in_GPR_READ_STATUS_"+toString(i)+"_"+toString(j)+"_DATA_VAL"   );
-	      _component->port_map(name_component,
-				   "in_READ_"+toString(j)+"_ADDRESS",
-				   _name,
-				   "in_GPR_READ_"+toString(j)+"_NUM_REG");
+              dest = _name+"_glue";
+              
+#ifdef POSITION
+              _component->interface_map (src ,    "read_"+toString(j),
+                                         dest,"gpr_read_status_"+toString(i)+"_"+toString(j));
+#endif
+
+	      COMPONENT_MAP(_component,src , "in_READ_"                           +toString(j)+"_VAL",
+                                       dest,"out_GPR_READ_STATUS_"+toString(i)+"_"+toString(j)+"_VAL");
+	      COMPONENT_MAP(_component,src ,"out_READ_"                           +toString(j)+"_ACK",
+                                       dest, "in_GPR_READ_STATUS_"+toString(i)+"_"+toString(j)+"_ACK");
+	      COMPONENT_MAP(_component,src ,"out_READ_"                           +toString(j)+"_DATA",
+                                       dest, "in_GPR_READ_STATUS_"+toString(i)+"_"+toString(j)+"_DATA_VAL");
+
+              dest = _name;
+              
+              PORT_MAP     (_component,src , "in_READ_"    +toString(j)+"_ADDRESS",
+                                       dest, "in_GPR_READ_"+toString(j)+"_NUM_REG");
 	    }
 
@@ -388,107 +398,51 @@
 	  for (uint32_t j=0; j<_param->_nb_gpr_write; j++)
 	    {
-	      _component->port_map(name_component,
-				   "in_WRITE_"+toString(x)+"_VAL" ,
-				   _name+"_glue",
-				   "out_GPR_WRITE_STATUS_"+toString(i)+"_"+toString(j)+"_VAL");
-	      _component->port_map(name_component,
-				   "out_WRITE_"+toString(x)+"_ACK",
-				   _name+"_glue",
-				   "in_GPR_WRITE_STATUS_"+toString(i)+"_"+toString(j)+"_ACK" );
-	      _component->port_map(name_component,
-				   "in_WRITE_"+toString(x)+"_DATA" ,
-				   _name+"_glue",
-				   "out_CONST_1");
-
-	      _component->port_map(_name+"_glue",
-				   "out_CONST_1",
-				   name_component,
-				   "in_WRITE_"+toString(x)+"_DATA" );
-
-
-	      _component->port_map(name_component,
-				   "in_WRITE_"+toString(x++)+"_ADDRESS",
-				   _name,
-				   "in_GPR_WRITE_"+toString(j)+"_NUM_REG");
+              dest = _name+"_glue";
+              
+#ifdef POSITION
+              _component->interface_map (src ,    "write_"+toString(j),
+                                         dest,"gpr_write_status_"+toString(i)+"_"+toString(j));
+#endif
+
+              COMPONENT_MAP(_component,src , "in_WRITE_"                           +toString(x)+"_VAL",
+                                       dest,"out_GPR_WRITE_STATUS_"+toString(i)+"_"+toString(j)+"_VAL");
+              COMPONENT_MAP(_component,src ,"out_WRITE_"                           +toString(x)+"_ACK",
+                                       dest, "in_GPR_WRITE_STATUS_"+toString(i)+"_"+toString(j)+"_ACK");
+              COMPONENT_MAP(_component,src , "in_WRITE_"                           +toString(x)+"_DATA",
+                                       dest,"out_GPR_WRITE_STATUS_"+toString(i)+"_"+toString(j)+"_DATA");
+//                                     dest,"out_CONST_1");
+              
+              dest = _name;
+              
+              PORT_MAP     (_component,src , "in_WRITE_"    +toString(x)+"_ADDRESS",
+                                       dest, "in_GPR_WRITE_"+toString(j)+"_NUM_REG");
+
+              x++;
 	    }
 	  
 	  for (uint32_t j=0; j<_param->_nb_inst_insert_rob [i]; j++)
 	    {
-	      _component->port_map(name_component,
-				   "in_WRITE_"+toString(x)+"_VAL" ,
-				   _name+"_glue",
-				   "out_INSERT_ROB_GPR_STATUS_"+toString(i)+"_"+toString(j)+"_VAL");
-	      _component->port_map(name_component,
-				   "out_WRITE_"+toString(x)+"_ACK",
-				   _name+"_glue",
-				   "in_INSERT_ROB_GPR_STATUS_"+toString(i)+"_"+toString(j)+"_ACK" );
-
-	      _component->port_map(name_component,
-				   "in_WRITE_"+toString(x)+"_DATA",
-				    _name+"_glue",
-				   "out_CONST_0"
-				   );
-	      _component->port_map( _name+"_glue",
-				    "out_CONST_0",
-				    name_component,
-				   "in_WRITE_"+toString(x)+"_DATA");
-
-	      _component->port_map(name_component,
-				   "in_WRITE_"+toString(x++)+"_ADDRESS",
-				   _name,
-				   "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RD_NUM_REG");
-
+              dest = _name+"_glue";
+              
+#ifdef POSITION
+              _component->interface_map (src ,    "write_"+toString(j),
+                                         dest,"insert_rob_gpr_status_"+toString(i)+"_"+toString(j));
+#endif
+
+              COMPONENT_MAP(_component,src , "in_WRITE_"                                +toString(x)+"_VAL",
+                                       dest,"out_INSERT_ROB_GPR_STATUS_"+toString(i)+"_"+toString(j)+"_VAL");
+              COMPONENT_MAP(_component,src ,"out_WRITE_"                                +toString(x)+"_ACK",
+                                       dest, "in_INSERT_ROB_GPR_STATUS_"+toString(i)+"_"+toString(j)+"_ACK");
+              COMPONENT_MAP(_component,src , "in_WRITE_"                                +toString(x)+"_DATA",
+                                       dest,"out_INSERT_ROB_GPR_STATUS_"+toString(i)+"_"+toString(j)+"_DATA");
+//                                     dest,"out_CONST_0");
+              
+              dest = _name;
+              
+              PORT_MAP     (_component,src , "in_WRITE_"                     +toString(x)+"_ADDRESS",
+                                       dest, "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RD_NUM_REG");
+
+              x++;
 	    }
-
-// 	  for (uint32_t j=0; j<_param->_nb_inst_retire_rob [i]; j++)
-// 	    {
-// 	      _component->port_map(name_component,
-// 				   "in_WRITE_"+toString(x)+"_VAL" ,
-// 				   _name+"_glue",
-// 				   "out_RETIRE_ROB_GPR_STATUS_OLD_"+toString(i)+"_"+toString(j)+"_VAL");
-// 	      _component->port_map(name_component,
-// 				   "out_WRITE_"+toString(x)+"_ACK",
-// 				   _name+"_glue",
-// 				   "in_RETIRE_ROB_GPR_STATUS_OLD_"+toString(i)+"_"+toString(j)+"_ACK" );
-
-// 	      _component->port_map(name_component,
-// 				   "in_WRITE_"+toString(x)+"_DATA" ,
-// 				   _name+"_glue",
-// 				   "out_CONST_0");
-// 	      _component->port_map(_name+"_glue",
-// 				   "out_CONST_0",
-// 				   name_component,
-// 				   "in_WRITE_"+toString(x)+"_DATA" );
-
-// 	      _component->port_map(name_component,
-// 				   "in_WRITE_"+toString(x++)+"_ADDRESS",
-// 				   _name,
-// 				   "in_RETIRE_ROB_"+toString(i)+"_"+toString(j)+"_RD_OLD_NUM_REG");
-	      
-// 	      _component->port_map(name_component,
-// 				   "in_WRITE_"+toString(x)+"_VAL" ,
-// 				   _name+"_glue",
-// 				   "out_RETIRE_ROB_GPR_STATUS_NEW_"+toString(i)+"_"+toString(j)+"_VAL");
-// 	      _component->port_map(name_component,
-// 				   "out_WRITE_"+toString(x)+"_ACK",
-// 				   _name+"_glue",
-// 				   "in_RETIRE_ROB_GPR_STATUS_NEW_"+toString(i)+"_"+toString(j)+"_ACK" );
-
-// 	      _component->port_map(name_component,
-// 				   "in_WRITE_"+toString(x)+"_DATA" ,
-// 				   _name+"_glue",
-// 				   "out_CONST_1"
-// 				   );
-// 	      _component->port_map(_name+"_glue",
-// 				   "out_CONST_1",
-// 				   name_component,
-// 				   "in_WRITE_"+toString(x)+"_DATA"
-// 				   );
-
-// 	      _component->port_map(name_component,
-// 				   "in_WRITE_"+toString(x++)+"_ADDRESS",
-// 				   _name,
-// 				   "in_RETIRE_ROB_"+toString(i)+"_"+toString(j)+"_RD_NEW_NUM_REG");
-// 	    }
 
 	}
@@ -497,54 +451,60 @@
     for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
       {
-	name_component = _name+"_spr_"+toString(i);
+	src = _name+"_spr_"+toString(i);
 	
-	log_printf(INFO,Register_unit,FUNCTION,_("Instance : %s"),name_component.c_str());
+	log_printf(INFO,Register_unit,FUNCTION,_("Instance : %s"),src.c_str());
 	
-#ifdef POSITION
-	_component->interface_map (name_component,"",
-				   _name         ,"");
-#endif
-	
-	_component->port_map(name_component,"in_CLOCK" , _name, "in_CLOCK");
-	_component->port_map(name_component,"in_NRESET", _name, "in_NRESET");
+        {
+          dest = _name;
+#ifdef POSITION
+          _component->interface_map (src ,"",
+                                     dest,"");
+#endif
+          PORT_MAP(_component,src , "in_CLOCK" ,dest, "in_CLOCK");
+          PORT_MAP(_component,src , "in_NRESET",dest, "in_NRESET");
+        }
 
 	for (uint32_t j=0; j<_param->_nb_spr_read; j++)
 	  {
-	    _component->port_map(name_component,
-				 "in_READ_"+toString(j)+"_VAL",
-				 _name+"_glue",
-				 "out_SPR_READ_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_VAL");
-	    _component->port_map(name_component,
-				 "out_READ_"+toString(j)+"_ACK",
-				 _name+"_glue",
-				 "in_SPR_READ_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_ACK");
-	    _component->port_map(name_component,
-				 "out_READ_"+toString(j)+"_DATA",
-				 _name+"_glue",
-				 "in_SPR_READ_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_DATA");
-	    _component->port_map(name_component,
-				 "in_READ_"+toString(j)+"_ADDRESS",
-				 _name,
-				 "in_SPR_READ_"+toString(j)+"_NUM_REG");
+            dest = _name+"_glue";
+            
+#ifdef POSITION
+            _component->interface_map (src ,    "read_"+toString(j),
+                                       dest,"spr_read_registerfile_"+toString(i)+"_"+toString(j));
+#endif
+
+	    COMPONENT_MAP(_component,src , "in_READ_"                                 +toString(j)+"_VAL",
+                                     dest,"out_SPR_READ_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_VAL");
+	    COMPONENT_MAP(_component,src ,"out_READ_"                                 +toString(j)+"_ACK",
+                                     dest, "in_SPR_READ_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_ACK");
+	    COMPONENT_MAP(_component,src ,"out_READ_"                                 +toString(j)+"_DATA",
+                                     dest, "in_SPR_READ_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_DATA");
+
+            dest = _name;
+
+	    PORT_MAP     (_component,src , "in_READ_"    +toString(j)+"_ADDRESS",
+                                     dest, "in_SPR_READ_"+toString(j)+"_NUM_REG");
 	  }
+
 	for (uint32_t j=0; j<_param->_nb_spr_write; j++)
 	  {
-	    _component->port_map(name_component,
-				 "in_WRITE_"+toString(j)+"_VAL",
-				 _name+"_glue",
-				 "out_SPR_WRITE_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_VAL");
-	    _component->port_map(name_component,
-				 "out_WRITE_"+toString(j)+"_ACK",
-				 _name+"_glue",
-				 "in_SPR_WRITE_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_ACK");
-	    _component->port_map(name_component,
-				 "in_WRITE_"+toString(j)+"_ADDRESS",
-				 _name,
-				 "in_SPR_WRITE_"+toString(j)+"_NUM_REG"
-				 );
-	    _component->port_map(name_component,
-				 "in_WRITE_"+toString(j)+"_DATA",
-				 _name,
-				 "in_SPR_WRITE_"+toString(j)+"_DATA");
+            dest = _name+"_glue";
+            
+#ifdef POSITION
+            _component->interface_map (src ,    "write_"+toString(j),
+                                       dest,"spr_write_registerfile_"+toString(i)+"_"+toString(j));
+#endif
+
+	    COMPONENT_MAP(_component,src , "in_WRITE_"                                 +toString(j)+"_VAL",
+                                     dest,"out_SPR_WRITE_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_VAL");
+	    COMPONENT_MAP(_component,src ,"out_WRITE_"                                 +toString(j)+"_ACK",
+                                     dest, "in_SPR_WRITE_REGISTERFILE_"+toString(i)+"_"+toString(j)+"_ACK");
+
+            dest = _name;
+
+	    PORT_MAP     (_component,src , "in_WRITE_"    +toString(j)+"_ADDRESS",
+                                     dest, "in_SPR_WRITE_"+toString(j)+"_NUM_REG");
+	    PORT_MAP     (_component,src , "in_WRITE_"    +toString(j)+"_DATA",
+                                     dest, "in_SPR_WRITE_"+toString(j)+"_DATA");
 	  }
 
@@ -554,34 +514,38 @@
       for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
 	{
-	  name_component = _name+"_spr_status_"+toString(i);
+	  src = _name+"_spr_status_"+toString(i);
 	  
-	  log_printf(INFO,Register_unit,FUNCTION,_("Instance : %s"),name_component.c_str());	
+	  log_printf(INFO,Register_unit,FUNCTION,_("Instance : %s"),src.c_str());	
   
-#ifdef POSITION
-	  _component->interface_map (name_component,"",
-				     _name         ,"");
-#endif
-	  
-	  _component->port_map(name_component,"in_CLOCK" , _name, "in_CLOCK");
-	  _component->port_map(name_component,"in_NRESET", _name, "in_NRESET");
-	  
+          {
+            dest = _name;
+#ifdef POSITION
+            _component->interface_map (src ,"",
+                                       dest,"");
+#endif
+            PORT_MAP(_component,src , "in_CLOCK" ,dest, "in_CLOCK");
+            PORT_MAP(_component,src , "in_NRESET",dest, "in_NRESET");
+          }
+
 	  for (uint32_t j=0; j<_param->_nb_spr_read; j++)
 	    {
-	      _component->port_map(name_component,
-				   "in_READ_"+toString(j)+"_VAL" ,
-				   _name+"_glue",
-				   "out_SPR_READ_STATUS_"+toString(i)+"_"+toString(j)+"_VAL"        );
-	      _component->port_map(name_component,
-				   "out_READ_"+toString(j)+"_ACK",
-				   _name+"_glue",
-				   "in_SPR_READ_STATUS_"+toString(i)+"_"+toString(j)+"_ACK" );
-	      _component->port_map(name_component,
-				   "out_READ_"+toString(j)+"_DATA",
-				   _name+"_glue",
-				   "in_SPR_READ_STATUS_"+toString(i)+"_"+toString(j)+"_DATA_VAL"   );
-	      _component->port_map(name_component,
-				   "in_READ_"+toString(j)+"_ADDRESS",
-				   _name,
-				   "in_SPR_READ_"+toString(j)+"_NUM_REG");
+              dest = _name+"_glue";
+              
+#ifdef POSITION
+              _component->interface_map (src ,    "read_"+toString(j),
+                                         dest,"spr_read_status_"+toString(i)+"_"+toString(j));
+#endif
+
+	      COMPONENT_MAP(_component,src , "in_READ_"                           +toString(j)+"_VAL",
+                                       dest,"out_SPR_READ_STATUS_"+toString(i)+"_"+toString(j)+"_VAL");
+	      COMPONENT_MAP(_component,src ,"out_READ_"                           +toString(j)+"_ACK",
+                                       dest, "in_SPR_READ_STATUS_"+toString(i)+"_"+toString(j)+"_ACK");
+	      COMPONENT_MAP(_component,src ,"out_READ_"                           +toString(j)+"_DATA",
+                                       dest, "in_SPR_READ_STATUS_"+toString(i)+"_"+toString(j)+"_DATA_VAL");
+
+              dest = _name;
+              
+              PORT_MAP     (_component,src , "in_READ_"    +toString(j)+"_ADDRESS",
+                                       dest, "in_SPR_READ_"+toString(j)+"_NUM_REG");
 	    }
 
@@ -589,108 +553,52 @@
 	  for (uint32_t j=0; j<_param->_nb_spr_write; j++)
 	    {
-	      _component->port_map(name_component,
-				   "in_WRITE_"+toString(x)+"_VAL" ,
-				   _name+"_glue",
-				   "out_SPR_WRITE_STATUS_"+toString(i)+"_"+toString(j)+"_VAL");
-	      _component->port_map(name_component,
-				   "out_WRITE_"+toString(x)+"_ACK",
-				   _name+"_glue",
-				   "in_SPR_WRITE_STATUS_"+toString(i)+"_"+toString(j)+"_ACK" );
-	      _component->port_map(name_component,
-				   "in_WRITE_"+toString(x)+"_DATA" ,
-				   _name+"_glue",
-				   "out_CONST_1");
-	      _component->port_map(_name+"_glue",
-				   "out_CONST_1",
-				   name_component,
-				   "in_WRITE_"+toString(x)+"_DATA"
-				   );
-
-	      _component->port_map(name_component,
-				   "in_WRITE_"+toString(x++)+"_ADDRESS",
-				   _name,
-				   "in_SPR_WRITE_"+toString(j)+"_NUM_REG");
+              dest = _name+"_glue";
+              
+#ifdef POSITION
+              _component->interface_map (src ,    "write_"+toString(j),
+                                         dest,"spr_write_status_"+toString(i)+"_"+toString(j));
+#endif
+
+              COMPONENT_MAP(_component,src , "in_WRITE_"                           +toString(x)+"_VAL",
+                                       dest,"out_SPR_WRITE_STATUS_"+toString(i)+"_"+toString(j)+"_VAL");
+              COMPONENT_MAP(_component,src ,"out_WRITE_"                           +toString(x)+"_ACK",
+                                       dest, "in_SPR_WRITE_STATUS_"+toString(i)+"_"+toString(j)+"_ACK");
+              COMPONENT_MAP(_component,src , "in_WRITE_"                           +toString(x)+"_DATA",
+                                       dest,"out_SPR_WRITE_STATUS_"+toString(i)+"_"+toString(j)+"_DATA");
+//                                     dest,"out_CONST_1");
+              
+              dest = _name;
+              
+              PORT_MAP     (_component,src , "in_WRITE_"    +toString(x)+"_ADDRESS",
+                                       dest, "in_SPR_WRITE_"+toString(j)+"_NUM_REG");
+
+              x++;
 	    }
 	  
 	  for (uint32_t j=0; j<_param->_nb_inst_insert_rob [i]; j++)
 	    {
-	      _component->port_map(name_component,
-				   "in_WRITE_"+toString(x)+"_VAL" ,
-				   _name+"_glue",
-				   "out_INSERT_ROB_SPR_STATUS_"+toString(i)+"_"+toString(j)+"_VAL");
-	      _component->port_map(name_component,
-				   "out_WRITE_"+toString(x)+"_ACK",
-				   _name+"_glue",
-				   "in_INSERT_ROB_SPR_STATUS_"+toString(i)+"_"+toString(j)+"_ACK" );
-
-	      _component->port_map(name_component,
-				   "in_WRITE_"+toString(x)+"_DATA",
-				    _name+"_glue",
-				   "out_CONST_0"
-				   );
-	      _component->port_map( _name+"_glue",
-				    "out_CONST_0",
-				   name_component,
-				   "in_WRITE_"+toString(x)+"_DATA"
-				   );
-
-	      _component->port_map(name_component,
-				   "in_WRITE_"+toString(x++)+"_ADDRESS",
-				   _name,
-				   "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RE_NUM_REG");
-
+              dest = _name+"_glue";
+              
+#ifdef POSITION
+              _component->interface_map (src ,    "write_"+toString(j),
+                                         dest,"insert_rob_spr_status_"+toString(i)+"_"+toString(j));
+#endif
+
+              COMPONENT_MAP(_component,src , "in_WRITE_"                                +toString(x)+"_VAL",
+                                       dest,"out_INSERT_ROB_SPR_STATUS_"+toString(i)+"_"+toString(j)+"_VAL");
+              COMPONENT_MAP(_component,src ,"out_WRITE_"                                +toString(x)+"_ACK",
+                                       dest, "in_INSERT_ROB_SPR_STATUS_"+toString(i)+"_"+toString(j)+"_ACK");
+              COMPONENT_MAP(_component,src , "in_WRITE_"                                +toString(x)+"_DATA",
+                                       dest,"out_INSERT_ROB_SPR_STATUS_"+toString(i)+"_"+toString(j)+"_DATA");
+//                                     dest,"out_CONST_0");
+              
+              dest = _name;
+              
+              PORT_MAP     (_component,src , "in_WRITE_"                     +toString(x)+"_ADDRESS",
+                                       dest, "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RE_NUM_REG");
+
+              x++;
 	    }
 
-// 	  for (uint32_t j=0; j<_param->_nb_inst_retire_rob [i]; j++)
-// 	    {
-// 	      _component->port_map(name_component,
-// 				   "in_WRITE_"+toString(x)+"_VAL" ,
-// 				   _name+"_glue",
-// 				   "out_RETIRE_ROB_SPR_STATUS_OLD_"+toString(i)+"_"+toString(j)+"_VAL");
-// 	      _component->port_map(name_component,
-// 				   "out_WRITE_"+toString(x)+"_ACK",
-// 				   _name+"_glue",
-// 				   "in_RETIRE_ROB_SPR_STATUS_OLD_"+toString(i)+"_"+toString(j)+"_ACK" );
-
-// 	      _component->port_map(name_component,
-// 				   "in_WRITE_"+toString(x)+"_DATA" ,
-// 				   _name+"_glue",
-// 				   "out_CONST_0");
-// 	      _component->port_map(_name+"_glue",
-// 				   "out_CONST_0",
-// 				   name_component,
-// 				   "in_WRITE_"+toString(x)+"_DATA"
-// 				   );
-
-// 	      _component->port_map(name_component,
-// 				   "in_WRITE_"+toString(x++)+"_ADDRESS",
-// 				   _name,
-// 				   "in_RETIRE_ROB_"+toString(i)+"_"+toString(j)+"_RE_OLD_NUM_REG");
-	      
-// 	      _component->port_map(name_component,
-// 				   "in_WRITE_"+toString(x)+"_VAL" ,
-// 				   _name+"_glue",
-// 				   "out_RETIRE_ROB_SPR_STATUS_NEW_"+toString(i)+"_"+toString(j)+"_VAL");
-// 	      _component->port_map(name_component,
-// 				   "out_WRITE_"+toString(x)+"_ACK",
-// 				   _name+"_glue",
-// 				   "in_RETIRE_ROB_SPR_STATUS_NEW_"+toString(i)+"_"+toString(j)+"_ACK" );
-
-// 	      _component->port_map(name_component,
-// 				   "in_WRITE_"+toString(x)+"_DATA" ,
-// 				   _name+"_glue",
-// 				   "out_CONST_1"
-// 				   );
-// 	      _component->port_map(_name+"_glue",
-// 				   "out_CONST_1",
-// 				   name_component,
-// 				   "in_WRITE_"+toString(x)+"_DATA"
-// 				   );
-
-// 	      _component->port_map(name_component,
-// 				   "in_WRITE_"+toString(x++)+"_ADDRESS",
-// 				   _name,
-// 				   "in_RETIRE_ROB_"+toString(i)+"_"+toString(j)+"_RE_NEW_NUM_REG");
-// 	    }
 
 	}
